#ifndef __SWI2C16_H
#define __SWI2C16_H

//#include "ifi_aliases.h"

//*******************************************************************************
// Define typedef structures
//*******************************************************************************
  
typedef unsigned char bit;                               // 1 Bit 
typedef unsigned char nib;                               // 4 Bit unsigned integer
typedef unsigned char byte;                              // 8 Bit unsigned integer
typedef unsigned int word;                               // 16 Bit unsigned integer
typedef unsigned long longword;                          // 32 Bit unsigned integer


/* PIC18 software I2C interface header */

/*****   COMMON FUNCTION PROTOTYPES   *****/

void SWStopI2C( void );                // Generate bus stop condition
void SWStartI2C( void );               // Generate bus start condition
void SWRestartI2C( void );             // Generate bus restart condition
void SWStopI2C( void );                // Generate bus stop condition
void SWNotAckI2C( void );              // Generate bus Not Ack condition

/*
// Vex Controller Digital I/O pins 
// Used in User_Initialization routine in user_routines.c file. 
// Used to set pins as INPUTS (analog or digital) or OUTPUTS (digital only). 
#define IO1             TRISAbits.TRISA0
#define IO2             TRISAbits.TRISA1
#define IO3             TRISAbits.TRISA2
#define IO4             TRISAbits.TRISA3
#define IO5             TRISAbits.TRISA5
#define IO6             TRISFbits.TRISF0
#define IO7             TRISFbits.TRISF1
#define IO8             TRISFbits.TRISF2
#define IO9             TRISFbits.TRISF3
#define IO10            TRISFbits.TRISF4
#define IO11            TRISFbits.TRISF5
#define IO12            TRISFbits.TRISF6   
#define IO13            TRISHbits.TRISH4  --> SCL 
#define IO14            TRISHbits.TRISH5  --> SDA
#define IO15            TRISHbits.TRISH6 
#define IO16            TRISHbits.TRISH7  --> SDA

// Aliases used to read the pins when used as INPUTS. 
#define rc_dig_in01     PORTAbits.RA0
#define rc_dig_in02     PORTAbits.RA1
#define rc_dig_in03     PORTAbits.RA2
#define rc_dig_in04     PORTAbits.RA3
#define rc_dig_in05     PORTAbits.RA5
#define rc_dig_in06     PORTFbits.RF0
#define rc_dig_in07     PORTFbits.RF1
#define rc_dig_in08     PORTFbits.RF2
#define rc_dig_in09     PORTFbits.RF3
#define rc_dig_in10     PORTFbits.RF4
#define rc_dig_in11     PORTFbits.RF5
#define rc_dig_in12     PORTFbits.RF6
#define rc_dig_in13     PORTHbits.RH4   --> SCL
#define rc_dig_in14     PORTHbits.RH5   --> SDA
#define rc_dig_in15     PORTHbits.RH6
#define rc_dig_in16     PORTHbits.RH7   --> SDA 


#define rc_dig_int1     PORTBbits.RB2
#define rc_dig_int2     PORTBbits.RB3   --> SCL
#define rc_dig_int3     PORTBbits.RB4   --> SDA
#define rc_dig_int4     PORTBbits.RB5
#define rc_dig_int5     PORTBbits.RB6
#define rc_dig_int6     PORTBbits.RB7

*/

/*
 *-------------------------------------------------------------------------------
 *---------- Aliases for PWM pins (PWM OUT 5-8 connectors) ----------------------
 *-------------------------------------------------------------------------------
 *  Below are aliases for the four PWM OUT pins which can be configured for use
 *  as digital inputs or outputs.  
 *
 *   The pin mapping is as follows:
 *   PWM OUT 5 -> OUT_PWM05
 *   PWM OUT 6 -> OUT_PWM06
 *   PWM OUT 7 -> OUT_PWM07
 *   PWM OUT 8 -> OUT_PWM08 
 
// To set the direction (output) of the pins you use these aliases. 
#define IO_PWM05        TRISEbits.TRISE0
#define IO_PWM06        TRISEbits.TRISE1
#define IO_PWM07        TRISEbits.TRISE2
#define IO_PWM08        TRISEbits.TRISE3

// When using them as outputs you drive a value with these aliases. 
#define OUT_PWM01       OUT_CCP2
#define OUT_PWM02       OUT_CCP3
#define OUT_PWM03       OUT_CCP4
#define OUT_PWM04       OUT_CCP5
#define OUT_PWM05       LATEbits.LATE0
#define OUT_PWM06       LATEbits.LATE1
#define OUT_PWM07       LATEbits.LATE2
#define OUT_PWM08       LATEbits.LATE3
*/

//#define SW_DIN_PIN PORTEbits.RE0      // Data in  pin using VEX PWM05
//#define TRIS_SW_DIN_PIN TRISEbits.TRISE0

#define SW_DIN_PIN PORTGbits.RG2      // Data in  pin using VEX PWM06 - did not work
#define TRIS_SW_DIN_PIN TRISGbits.TRISG2
//#define SW_DIN_PIN PORTGbits.RG3        // Data in  pin using VEX PWM03 
//#define TRIS_SW_DIN_PIN TRISGbits.TRISG3


#define SW_DOUT_PIN LATGbits.LATG2        // Data out pin using VEX PWM06 - did not work
#define TRIS_SW_DOUT_PIN  TRISGbits.TRISG2
//#define SW_DOUT_PIN LATGbits.LATG3      // Data out pin using VEX PWM03  
//#define TRIS_SW_DOUT_PIN  TRISGbits.TRISG3

#define SW_SCK_PIN LATGbits.LATG1         // Clock  pin using VEX PWM07 - did not work
#define TRIS_SW_SCK_PIN TRISGbits.TRISG1
//#define SW_SCK_PIN LATGbits.LATG4       // Clock  pin using VEX PWM04
//#define TRIS_SW_SCK_PIN TRISGbits.TRISG4



//#define CSEE    PORTEbits.RE3           // select line for Serial EEPROM using VEX PWM08
//#define TCSEE   TRISEbits.TRISE3        // tris control for CSEE pin on PIC18F8720
//#define SW_CS_PIN LATEbits.LATE3        // Chip Select  on PIC18F8720
//#define TRIS_SW_CS_PIN TRISEbits.TRISE3


// USER NEEDS TO DEFINE DATA AND CLOCK PINS. RESISTORS ARE REQUIRED ON 
// DATA AND CLOCK PINS.

//#define  DATA_LOW   IO16 = 0; // define macro for data pin output
#define  DATA_LOW   TRIS_SW_DOUT_PIN = 0; // define macro for data pin output


#define  DATA_HI    TRIS_SW_DIN_PIN = 1; // define macro for data pin input


//#define  DATA_LAT   rc_dig_out16         // define macro for data pin latch
#define  DATA_LAT  SW_DOUT_PIN         // Data out pin using VEX PWM06

//#define  DATA_PIN   rc_dig_in16         // define macro for data pin
#define  DATA_PIN   SW_DIN_PIN         // define macro for data pin using VEX PWM06

#define  CLOCK_LOW  TRIS_SW_SCK_PIN = 0; // define macro for clock pin output
#define  CLOCK_HI   TRIS_SW_SCK_PIN = 1; // define macro for clock pin input

//#define  SCLK_LAT   rc_dig_out13         // define macro for clock pin latch
#define  SCLK_LAT   SW_SCK_PIN         // Clock  pin using VEX PWM07

//#define  SCLK_PIN   rc_dig_in13         // define macro for clock pin
#define  SCLK_PIN   TRIS_SW_SCK_PIN        // define macro for clock pin using VEX PWM07

#define   SDA_PIN  PORTGbits.RG2        // Data in  pin using VEX PWM06 - Did not Work
#define   SDA_DIR  TRISGbits.TRISG2   
//#define   SDA_PIN  PORTGbits.RG3        // Data in  pin using VEX PWM03 
//#define   SDA_DIR  TRISGbits.TRISG3   


#define   SCL_PIN  LATGbits.LATG1       // Clock  pin using VEX PWM07 - Did not work
#define   SCL_DIR  TRISGbits.TRISG1
//#define   SCL_PIN  LATGbits.LATG4       // Clock  pin using VEX PWM04
//#define   SCL_DIR  TRISGbits.TRISG4

/*
#if defined(__18F1220) || defined(__18F1320) || defined(__18F8520) || defined(__18F8720)
#define  DATA_LOW   TRISBbits.TRISB4 = 0; // define macro for data pin output
#define  DATA_HI    TRISBbits.TRISB4 = 1; // define macro for data pin input
#define  DATA_LAT   LATBbits.LATB4        // define macro for data pin latch
#define  DATA_PIN   PORTBbits.RB4         // define macro for data pin

#define  CLOCK_LOW  TRISBbits.TRISB3 = 0; // define macro for clock pin output
#define  CLOCK_HI   TRISBbits.TRISB3 = 1; // define macro for clock pin input
#define  SCLK_LAT   LATBbits.LATB3        // define macro for clock pin latch
#define  SCLK_PIN   PORTBbits.RB3         // define macro for clock pin
#elif defined(__18F2455) || defined(__18F2550) || \
      defined(__18F4455) || defined(__18F4550)

#define  DATA_LOW   TRISBbits.TRISB0 = 0; // define macro for data pin output
#define  DATA_HI    TRISBbits.TRISB0 = 1; // define macro for data pin input
#define  DATA_LAT   LATBbits.LATB0        // define macro for data pin latch
#define  DATA_PIN   PORTBbits.RB0         // define macro for data pin

#define  CLOCK_LOW  TRISBbits.TRISB1 = 0; // define macro for clock pin output
#define  CLOCK_HI   TRISBbits.TRISB1 = 1; // define macro for clock pin input
#define  SCLK_LAT   LATBbits.LATB1        // define macro for clock pin latch
#define  SCLK_PIN   PORTBbits.RB1         // define macro for clock pin

#else

#define  DATA_LOW   TRISCbits.TRISC4 = 0; // define macro for data pin output
#define  DATA_HI    TRISCbits.TRISC4 = 1; // define macro for data pin input
#define  DATA_LAT   LATCbits.LATC4        // define macro for data pin latch
#define  DATA_PIN   PORTCbits.RC4         // define macro for data pin

#define  CLOCK_LOW  TRISCbits.TRISC3 = 0; // define macro for clock pin output
#define  CLOCK_HI   TRISCbits.TRISC3 = 1; // define macro for clock pin input
#define  SCLK_LAT   LATCbits.LATC3        // define macro for clock pin latch
#define  SCLK_PIN   PORTCbits.RC3         // define macro for clock pin
#endif
*/

/*****   FUNCTION PROTOTYPES FOR PIC18CXXX   *****/
unsigned char SWAckI2C( void );          // This function generates a bus acknowledge sequence. 
unsigned char SWNackI2C( void );         // This function generates a Not bus acknowledge sequence
//signed char SWAckI2C( void );          // This function generates a bus acknowledge sequence. 
//unsigned char SWAckI2C( void );        // Read bus ACK condition
//unsigned char Clock_test( void );
signed char Clock_test( void );
unsigned int  SWReadI2C( void );       // Read in single byte 
unsigned char SWWriteI2C( unsigned char data_out ); // Write out single byte
unsigned char SWGetsI2C( unsigned char *rdptr, unsigned char length );   // Read in string from I2C module
unsigned char SWPutsI2C(  unsigned char *wrptr );    // Write string to I2C module
int I2C_Test(void);

#define  SWPutcI2C    SWWriteI2C
#define  SWGetcI2C    SWReadI2C
#define  SWNotAckI2C  SWAckI2C

// Declare function headers here
void init_i2c(void);
void random_write(byte dev_adr, long mem_adr, byte dat);
byte random_read(byte dev_adr, long mem_adr);
byte i2c_in_byte(void);
void i2c_out_byte(byte o_byte);
void i2c_nack(void);
void i2c_ack(void);
void i2c_start(void);
void i2c_stop(void);
void i2c_high_sda(void);
void i2c_low_sda(void);
void i2c_high_scl(void);
void i2c_low_scl(void);
void delay_ms(long t);  // delays t millisecs
void delay_10us(int t);
void lcd_init(void);

int Get_Compass_Heading(void);

#endif
/*  end  swi2c16.h file */








